Bug 15714 - InnerClasses attribute mishandled
Summary: InnerClasses attribute mishandled
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: java (show other bugs)
Version: 4.0.0
: P2 normal
Target Milestone: 4.3.0
Assignee: Not yet assigned to anyone
URL:
Keywords:
Depends on: 4105 28067
Blocks: 18131
  Show dependency treegraph
 
Reported: 2004-05-28 19:13 UTC by Tom Tromey
Modified: 2007-01-09 20:46 UTC (History)
2 users (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed: 2005-07-23 05:24:37


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Tom Tromey 2004-05-28 19:13:00 UTC
The InnerClasses attribute in a .class file must have
an entry for any nested class referenced by the .class file.
Currently gcj does not do this.  For instance, from
java.util.AbstractMap:

Attribute "InnerClasses", length:26
  inner: java.util.AbstractMap$BasicMapEntry, access flags: 0x8 static, outer
class: java.util.AbstractMap
  inner: java.util.AbstractMap$3 (anonymous), access flags: 0x12 private final,
outer class: <constant pool index 0 not in range>
  inner: java.util.AbstractMap$1 (anonymous), access flags: 0x12 private final,
outer class: <constant pool index 0 not in range>


However, this class refers to :

 29: checkcast <Class java.util.Map$Entry>
 32: invokeinterface <InterfaceMethod java.util.Map$Entry.getKey
()java.lang.Object> nargs:1
Comment 1 Andrew Pinski 2004-05-28 19:17:02 UTC
Confirmed.
Comment 2 Tom Tromey 2007-01-09 20:46:09 UTC
All gcj front end bugs have been fixed by the gcj-eclipse branch merge.
I'm mass-closing the affected PRs.
If you believe one of these was closed in error, please reopen it
with a note explaining why.
Thanks.